From 42f8b8c23e881d291ca07c3566d9efac1f46392a Mon Sep 17 00:00:00 2001
From: KOLANICH <KOLANICH@user.github.com>
Date: Fri, 27 Sep 2019 17:09:03 +0300
Subject: [PATCH] Added creation of a deb package

---
 CMakeLists.txt                   | 23 +++++++++++++++++++++++
 CPack.llvm-spirv.description.txt |  1 +
 2 files changed, 24 insertions(+)
 create mode 100644 CPack.llvm-spirv.description.txt

diff --git a/CMakeLists.txt b/CMakeLists.txt
index ecebb4c..c9fa33e 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -14,6 +14,7 @@ if (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)
   endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
 endif (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)
 
+option(LLVM_SPIRV_BUILD_EXTERNAL "we build inside llvm or not" "${LLVM_SPIRV_BUILD_EXTERNAL}")
 if(LLVM_SPIRV_BUILD_EXTERNAL)
   project(LLVM_SPIRV
     VERSION
@@ -82,3 +83,25 @@ install(
   DESTINATION
     ${CMAKE_INSTALL_PREFIX}/lib${LLVM_LIBDIR_SUFFIX}/pkgconfig
 )
+
+if(LLVM_SPIRV_BUILD_EXTERNAL)
+  set(CPACK_PACKAGE_NAME "llvm-spirv")
+  set(CPACK_PACKAGE_VENDOR "The Khronos Group")
+  set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/CPack.${CPACK_PACKAGE_NAME}.description.txt")
+  set(CPACK_PACKAGE_HOMEPAGE_URL "https://github.com/KhronosGroup/SPIRV-LLVM-Translator")
+  set(CPACK_PACKAGE_CONTACT "https://github.com/KhronosGroup/SPIRV-LLVM-Translator")
+  set(CPACK_PACKAGE_CHECKSUM "SHA512")
+  set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE.TXT")
+  set(CPACK_DEBIAN_PACKAGE_VERSION "${LLVM_VERSION}-${LLVM_SPIRV_VERSION}") #  in Ubuntu version of llvm is used as version
+  set(CPACK_GENERATOR "DEB")
+
+  string(REPLACE "." ";" LLVM_VERSION_PARSED "${LLVM_VERSION}")
+  list(GET LLVM_VERSION_PARSED 0 LLVM_VERSION_MAJOR)
+  list(GET LLVM_VERSION_PARSED 1 LLVM_VERSION_MINOR)
+
+  set(CPACK_DEBIAN_PACKAGE_DEPENDS "libllvm${LLVM_VERSION_MAJOR} (>= ${LLVM_VERSION_MAJOR}),libc6")
+  set(CPACK_DEBIAN_PACKAGE_PROVIDES "libllvmspirv${LLVM_VERSION_MAJOR}")
+  set(CPACK_DEBIAN_PACKAGE_REPLACES "libllvmspirv${LLVM_VERSION_MAJOR}")
+
+  include(CPack)
+endif()
\ No newline at end of file
diff --git a/CPack.llvm-spirv.description.txt b/CPack.llvm-spirv.description.txt
new file mode 100644
index 0000000..1722caa
--- /dev/null
+++ b/CPack.llvm-spirv.description.txt
@@ -0,0 +1 @@
+SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This package includes a library and a tool for translation between LLVM IR and SPIR-V.
-- 
2.20.1

